'''
this is a part of the heybuddy project
copyright 2010 jezra lickter http://www.jezra.net
'''
from base64 import b64encode
from urllib import urlencode
import urllib2
import gobject
from threading import Thread
#import thread
from time import sleep
class Communicator(gobject.GObject,Thread):
	__gsignals__ = {
		'statusesXML': (
			gobject.SIGNAL_RUN_FIRST, gobject.TYPE_NONE,
							 (gobject.TYPE_STRING,)
			),
		'mentionsXML': (
			gobject.SIGNAL_RUN_FIRST, gobject.TYPE_NONE,
							 (gobject.TYPE_STRING,)
			),
		'group-statusesXML': (
			gobject.SIGNAL_RUN_FIRST, gobject.TYPE_NONE,
							 (gobject.TYPE_STRING,)
			),
		'user-statusesXML': (
			gobject.SIGNAL_RUN_FIRST, gobject.TYPE_NONE,
							 (gobject.TYPE_STRING,)
			),
		'conversationXML': (
			gobject.SIGNAL_RUN_FIRST, gobject.TYPE_NONE,
							 (gobject.TYPE_STRING,gobject.TYPE_STRING)
			),
		'new-statusXML': (
			gobject.SIGNAL_RUN_FIRST, gobject.TYPE_NONE,
							 (gobject.TYPE_STRING,)
			),
		'userXML': (
			gobject.SIGNAL_RUN_FIRST, gobject.TYPE_NONE,
							 (gobject.TYPE_STRING,)
			),
		'groupXML': (
			gobject.SIGNAL_RUN_FIRST, gobject.TYPE_NONE,
							 (gobject.TYPE_STRING,)
			),
		'join-groupXML': (
			gobject.SIGNAL_RUN_FIRST, gobject.TYPE_NONE,
							 (gobject.TYPE_STRING,)
			),
		'leave-groupXML': (
			gobject.SIGNAL_RUN_FIRST, gobject.TYPE_NONE,
							 (gobject.TYPE_STRING,)
			),
		'direct_messagesXML': (
			gobject.SIGNAL_RUN_FIRST, gobject.TYPE_NONE,
							 (gobject.TYPE_STRING,)
			),
		'user_is_friendXML': (
			gobject.SIGNAL_RUN_FIRST, gobject.TYPE_NONE,
							 (gobject.TYPE_STRING,)
			),
		'user_is_memberXML': (
			gobject.SIGNAL_RUN_FIRST, gobject.TYPE_NONE,
							 (gobject.TYPE_STRING,)
			),
		'memberXML': (
			gobject.SIGNAL_RUN_FIRST, gobject.TYPE_NONE,
							 (gobject.TYPE_STRING,)
			),
		'friendshipXML': (
			gobject.SIGNAL_RUN_FIRST, gobject.TYPE_NONE,
							 (gobject.TYPE_STRING,)
			),
		'exception-caught': (
			gobject.SIGNAL_RUN_FIRST, gobject.TYPE_NONE,
							 (gobject.TYPE_STRING,)
			),
		'widget-image': (
			gobject.SIGNAL_RUN_FIRST, gobject.TYPE_NONE,
							 (gobject.TYPE_PYOBJECT,gobject.TYPE_STRING)
			),
		'direct-messageXML': (
			gobject.SIGNAL_RUN_FIRST, gobject.TYPE_NONE,
							 (gobject.TYPE_STRING,)
			),
		'block-createXML': (
			gobject.SIGNAL_RUN_FIRST, gobject.TYPE_NONE,
							 (gobject.TYPE_STRING,)
			),
		'block-destroyXML': (
			gobject.SIGNAL_RUN_FIRST, gobject.TYPE_NONE,
							 (gobject.TYPE_STRING,)
			),
	}
	
	def __init__(self,app_name=None,name=None,password=None):
		gobject.GObject.__init__(self)
		Thread.__init__(self)
		self.queue = []
		self.name = name
		self.password = password
		self.agent = app_name
		self.apiroot="http://identi.ca/api"
		self.sapiroot="https://identi.ca/api"
		
	def set_name_and_password(self,name,password):
		self.name=name
		self.password = password
		self.rebuild_opener()
		
	def set_initial_dents(self,value):
		self.status_append = "&count=%s" % (value)
		
	def rebuild_opener(self):
		auth_handler = urllib2.HTTPBasicAuthHandler()
		auth_handler.add_password(realm='Identi.ca API',
									uri='http://identi.ca/api',
									user=self.name,
									passwd=self.password)
		self.opener = urllib2.build_opener(auth_handler)
		# make the authentication header
		authstring = '%s:%s' % (self.name, self.password)
		self.authheader =	"Basic %s" % b64encode(authstring)
			
	def get_statuses(self,since_id):
		url = "%s/statuses/friends_timeline/%s.xml?since_id=%d%s" % (self.apiroot,self.name,since_id,self.status_append)
		print url
		self.process_httprequest(url,'statusesXML')
	
	def check_validity(self,name,password):
		pass
		
	def get_widget_image(self,image):
		self.get_image(image,'widget-image')
	
	def get_image(self,image,signal):	
		url=image
		print url
		self.process_httprequest(url,signal,image)
		
	def get_conversation(self,id,conversation_id):
		url="%s/statuses/show/%d.xml" % (self.sapiroot,id)
		print url
		request = urllib2.Request(url)
		request.add_header("Authorization", self.authheader)
		self.process_httprequest(request,'conversationXML',conversation_id)
		
	def get_mentions(self,since_id):
		url = "%s/statuses/mentions/%s.xml?since_id=%d%s" % (self.apiroot,self.name,since_id,self.status_append)
		print url
		self.process_httprequest(url,'mentionsXML') 
	
	def	get_user_info(self,name):
		url="%s/users/show.xml?screen_name=%s" % (self.apiroot,name)
		print url
		request = urllib2.Request(url)
		request.add_header("Authorization", self.authheader)
		self.process_httprequest(request,'userXML') 
	
	def get_user_statuses(self,name):
		url="%s/statuses/user_timeline.xml?screen_name=%s" % (self.sapiroot,name)
		print url
		request = urllib2.Request(url)
		request.add_header("Authorization", self.authheader)
		self.process_httprequest(request,'user-statusesXML')
	
	def get_user_is_friend(self,name):
		#is the user a friend?
		url="%s/friendships/exists.xml?user_a=%s&user_b=%s" % (self.apiroot,self.name,name)
		print url
		self.process_httprequest(url,'user_is_friendXML') 
	
	def favorite(self,id):
		#favorite this thing
		url="%s/favorites/create/%s.xml" % (self.sapiroot,id)
		print url
		request = urllib2.Request(url,"")
		request.add_header("Authorization", self.authheader)
		self.process_httprequest(request,None)
		
	def unfavorite(self,id):
		#favorite this thing
		url="%s/favorites/destroy/%s.xml" % (self.sapiroot,id)
		print url
		request = urllib2.Request(url,"")
		request.add_header("Authorization", self.authheader)
		self.process_httprequest(request,None)
	
	def	get_group_info(self,name):
		url="%s/statusnet/groups/show/%s.xml" % (self.sapiroot,name)
		print url
		request = urllib2.Request(url,"")
		request.add_header("Authorization", self.authheader)
		self.process_httprequest(request,'groupXML') 
	
	def	get_group_statuses(self,name):
		url="%s/statusnet/groups/timeline/%s.xml" % (self.apiroot,name)
		print url
		request = urllib2.Request(url,"")
		self.process_httprequest(request,'group-statusesXML') 
	
		
	def get_user_is_member(self,group_name):
		#is the user a friend?
		url="%s/statusnet/groups/is_member.xml?screen_name=%s&group_id=%s" % (self.apiroot,self.name,group_name)
		print url
		#request = urllib2.Request(url)
		self.process_httprequest(url,'user_is_memberXML') 
	
	def get_direct_messages(self,id):
		url="%s/direct_messages.xml?since_id=%d" % (self.sapiroot,id)
		print url
		request = urllib2.Request(url,"")
		request.add_header("Authorization", self.authheader)
		self.process_httprequest(request,'direct_messagesXML')
	
	def friendship_create(self,name):
		url="%s/friendships/create/%s.xml" % (self.sapiroot,name)
		print url
		request = urllib2.Request(url,"")
		request.add_header("Authorization", self.authheader)
		self.process_httprequest(request,'friendshipXML')
	
	def friendship_destroy(self,name):
		url="%s/friendships/destroy.xml?screen_name=%s" % (self.sapiroot,name)
		print url
		request = urllib2.Request(url,"")
		request.add_header("Authorization", self.authheader)
		self.process_httprequest(request,'friendshipXML')
		
	def group_join(self,group_id):
		url="%s/statusnet/groups/join.xml" % (self.sapiroot)
		print url
		request = urllib2.Request(url,"id=%s" % (group_id) )
		request.add_header("Authorization", self.authheader)
		self.process_httprequest(request,'join-groupXML')
	
	def group_leave(self,group_id):
		url="%s/statusnet/groups/leave.xml" % (self.sapiroot)
		print url
		request = urllib2.Request(url,"id=%s" % (group_id) )
		request.add_header("Authorization", self.authheader)
		self.process_httprequest(request,'leave-groupXML')
		
	def send_update_status(self,text,respond_to_id=0):
		data={"status":text,"source":self.agent} 
		if(respond_to_id>0):
			data["in_reply_to_status_id"]=respond_to_id
		encoded_data =urlencode(data)
		url="%s/statuses/update.xml" % (self.sapiroot)
		print url
		request = urllib2.Request(url,encoded_data)
		request.add_header("Authorization", self.authheader)
		self.process_httprequest(request,'new-statusXML')

	def send_redent(self,status_id):
		url="%s/statuses/retweet/%s.xml" % (self.apiroot,status_id)
		print url
		request = urllib2.Request(url,encoded_data)
		self.process_httprequest(request,'redent-statusXML')
	
	def block_create(self,user_id):
		url="%s/blocks/create.xml?user_id=%s" % (self.sapiroot,user_id)
		print url
		request = urllib2.Request(url,'')
		request.add_header("Authorization", self.authheader)
		self.process_httprequest(request,'block-createXML')
		
	def block_destroy(self,user_id):
		url="%s/blocks/destroy.xml?user_id=%s" % (self.sapiroot,user_id)
		print url
		request = urllib2.Request(url,'')
		request.add_header("Authorization", self.authheader)
		self.process_httprequest(request,'block-destroyXML')
		
	def send_direct_message( self, text, screen_name):
		data={"text":text,"screen_name":screen_name,"source":self.agent}
		encoded_data=urlencode(data)
		url="%s/direct_messages/new.xml" % (self.sapiroot)
		print url
		request = urllib2.Request(url,encoded_data)
		request.add_header("Authorization", self.authheader)
		self.process_httprequest(request,'direct-messageXML')
		
	def quit(self):
		self.looping = False
	
	def run(self):
		self.looping = True
		while self.looping:
			#are there any requests in the queue?
			if len(self.queue)>0:
				#pop the first item
				(request,signal,data) = self.queue.pop(0)
				#run the request
				self.threaded_request(request,signal,data)
			#take a nap
			sleep(1)	
			

	def process_httprequest(self,request,signal=None,data=None):
		self.queue.append( (request,signal,data) )

	def threaded_request(self,request,signal,data):
		try:
			#f=self.opener.open(request)
			f=urllib2.urlopen(request)
			#read the data
			text = f.read()
			#pass the data as a signal
			if signal!=None:
				print "emitting %s signal" % (signal)
				if data!=None:
					#pack the data 
					gobject.idle_add(self.emit,signal,text,data)
				else:
					gobject.idle_add(self.emit,signal,text)
				
		except urllib2.HTTPError, e :
			self.emit("exception-caught",e.code)
		except Exception,error:
			try: 
				print error
			except:
				pass
			self.emit("exception-caught", "unknown error")

