'''
this is a part of the heybuddy project
copyright 2010 jezra lickter http://www.jezra.net
'''
from FilterFrame import FilterFrame
import gtk,gobject
import PlatformSpecific
#make a enum like thing
TAGS = range(1)

class FilterPage(gtk.VBox,gobject.GObject):
  __gsignals__={
    'add-tag-filter': (
      gobject.SIGNAL_RUN_FIRST, gobject.TYPE_NONE,
             (gobject.TYPE_STRING,)
    ),
    'remove-tag-filter' : (
      gobject.SIGNAL_RUN_FIRST,gobject.TYPE_NONE,
        (gobject.TYPE_STRING,)
    ),
    'add-group-filter': (
      gobject.SIGNAL_RUN_FIRST, gobject.TYPE_NONE,
             (gobject.TYPE_STRING,)
    ),
    'remove-group-filter' : (
      gobject.SIGNAL_RUN_FIRST,gobject.TYPE_NONE,
        (gobject.TYPE_STRING,)
    ),
    'add-user-filter': (
      gobject.SIGNAL_RUN_FIRST, gobject.TYPE_NONE,
             (gobject.TYPE_STRING,)
    ),
    'remove-user-filter' : (
      gobject.SIGNAL_RUN_FIRST,gobject.TYPE_NONE,
        (gobject.TYPE_STRING,)
    )
  }
  
  def __init__(self):
    gtk.VBox.__init__(self)
    gobject.GObject.__init__(self)
    self.set_homogeneous(False)
    self.set_border_width(5)
    vbox = gtk.VBox(False)
    scroller = PlatformSpecific.ScrollThingy()
    #TODO:move the filter frames to the mainwindow class to cut down on signal passing
    #create and add a FilterFrame for Tags
    self.tagfilterframe = FilterFrame("Tag")
    vbox.pack_start(self.tagfilterframe)
    #connect the tagfilterframe
    self.tagfilterframe.connect('add-filter', self.add_tag_filter)
    self.tagfilterframe.connect('remove-filter', self.remove_tag_filter)
    
    #create and add a FilterFrame for groups
    self.groupfilterframe = FilterFrame("Group")
    vbox.pack_start(self.groupfilterframe)
    #connect the groupfilterframe
    self.groupfilterframe.connect('add-filter', self.add_group_filter)
    self.groupfilterframe.connect('remove-filter', self.remove_group_filter)
    
    #create and add a FilterFrame for users
    self.userfilterframe = FilterFrame("User")
    vbox.pack_start(self.userfilterframe)
    #connect the userfilterframe
    self.userfilterframe.connect('add-filter', self.add_user_filter)
    self.userfilterframe.connect('remove-filter', self.remove_user_filter)
    
    #put the vbox in a view port
    vport = gtk.Viewport()
    vport.set_shadow_type(gtk.SHADOW_NONE)
    vport.add(vbox)
    #add the vport to the scrollthingy
    scroller.add(vport)
    self.pack_start(scroller)

  def add_tag_filter(self,filterframe,tag):
    self.emit('add-tag-filter',tag)
    
  def remove_tag_filter(self,filterframe,tag):
    self.emit('remove-tag-filter',tag)

  def set_tag_filters(self, filters ):
    self.tagfilterframe.set_filters(filters)


  def add_group_filter(self,filterframe,group):
    self.emit('add-group-filter',group)
    
  def remove_group_filter(self,filterframe,group):
    self.emit('remove-group-filter',group)

  def set_group_filters(self, filters ):
    self.groupfilterframe.set_filters(filters)


  def add_user_filter(self,filterframe,user):
    self.emit('add-user-filter',user)
    
  def remove_user_filter(self,filterframe,user):
    self.emit('remove-user-filter',user)

  def set_user_filters(self, filters ):
    self.userfilterframe.set_filters(filters)
