'''
this is a part of the heybuddy project
copyright 2010 jezra lickter http://www.jezra.net
'''
import gtk
import gobject
import PlatformSpecific
class SettingsPage(gtk.VBox,gobject.GObject):
	__gsignals__={
		'update-account': (
			gobject.SIGNAL_RUN_FIRST, gobject.TYPE_NONE,
							 (gobject.TYPE_STRING,gobject.TYPE_STRING)
			),
		'option-run-as-tray-app': (
			gobject.SIGNAL_RUN_FIRST, gobject.TYPE_NONE,
						 (gobject.TYPE_BOOLEAN,)
		),
		'option-context-backwards': (
			gobject.SIGNAL_RUN_FIRST, gobject.TYPE_NONE,
						 (gobject.TYPE_BOOLEAN,)
		),
		'option-no-avatars': (
			gobject.SIGNAL_RUN_FIRST, gobject.TYPE_NONE,
						 (gobject.TYPE_BOOLEAN,)
		),
		'option-notifications':(
			gobject.SIGNAL_RUN_FIRST, gobject.TYPE_NONE,
						 (gobject.TYPE_BOOLEAN,)
		),
		'option-notify-replies':(
			gobject.SIGNAL_RUN_FIRST, gobject.TYPE_NONE,
						 (gobject.TYPE_BOOLEAN,)
		),
		'initial-dents': (
			gobject.SIGNAL_RUN_FIRST, gobject.TYPE_NONE,
						 (gobject.TYPE_INT,)
		),
		'link-color': (
			gobject.SIGNAL_RUN_FIRST, gobject.TYPE_NONE,
						 (gobject.TYPE_STRING,)
		),
	}
	
	def __init__(self,has_hildon=False,has_pynotify=False):
		self.has_hildon=has_hildon
		gtk.VBox.__init__(self)
		gobject.GObject.__init__(self)
		self.set_homogeneous(False)
		self.set_border_width(5)
		#make this a scrollable thing
		vbox = gtk.VBox(False)
		scroller = PlatformSpecific.ScrollThingy()
		#put the vbox in a view port
		vport = gtk.Viewport()
		vport.set_shadow_type(gtk.SHADOW_NONE)
		vport.add(vbox)
		#add the vport to the scrollthingy
		scroller.add(vport)
		self.pack_start(scroller)
		
		#start with a table
		table = gtk.Table(3,2)
		table.attach(gtk.Label("Name:"),0,1,0,1,gtk.SHRINK,gtk.SHRINK)
		table.attach(gtk.Label("Password:"),0,1,1,2,gtk.SHRINK,gtk.SHRINK)
		self.account_name_entry = gtk.Entry()
		self.account_password_entry = gtk.Entry()
		self.account_password_entry.set_invisible_char("*")
		self.account_password_entry.set_visibility(False)
		#add the entries to the table
		table.attach(self.account_name_entry,1,2,0,1,gtk.SHRINK,gtk.SHRINK)
		table.attach(self.account_password_entry,1,2,1,2,gtk.SHRINK,gtk.SHRINK)
		#make a button to register "submit clicks
		enter_button = gtk.Button("Submit")
		enter_button.connect("clicked", self.submit_clicked)
		#attach the button to the table
		table.attach(enter_button,1,2,2,3,gtk.SHRINK,gtk.SHRINK)
		account_frame = gtk.Frame("Account")
		account_frame.add(table)
		vbox.pack_start(account_frame,False,False,0)
		#add the options settings
		options_box = gtk.VBox(False)
		self.run_as_tray_app = gtk.CheckButton("Run as tray application")
		self.run_as_tray_app.connect("toggled", self.option_toggled,'option-run-as-tray-app')
		self.context_back_asswards = gtk.CheckButton("Conversation: oldest first")
		self.context_back_asswards.connect("toggled", self.option_toggled,'option-context-backwards')
		self.disable_avatars = gtk.CheckButton("Disable avatar downloading")
		self.disable_avatars.connect("toggled", self.option_toggled,'option-no-avatars')

		self.enable_notifications = gtk.CheckButton("Enable notifications")
		self.enable_notifications.connect("toggled", self.option_toggled,'option-notifications')
		self.enable_notify_replies = gtk.CheckButton("Enable @replies notifications")
		self.enable_notify_replies.connect("toggled", self.option_toggled,'option-notify-replies')

		options_box.pack_start(self.run_as_tray_app,False,False,0)
		options_box.pack_start(self.context_back_asswards,False,False,0)
		options_box.pack_start(self.disable_avatars,False,False,0)
		#does the app have notifications?
		if has_pynotify:
			options_box.pack_start(self.enable_notifications,False,False,0)
			options_box.pack_start(self.enable_notify_replies,False,False,0)
		options_frame = gtk.Frame("Options")
		options_frame.add(options_box)
		vbox.pack_start(options_frame,False,False,0)
		#initial dents
		idhbox = gtk.HBox(False)
		idhbox.pack_start(gtk.Label("Number of dents at start-up: "),False,False,0)
		self.initial_dents = gtk.HScale()
		self.initial_dents.connect('value-changed', self.initial_dents_changed)
		self.initial_dents.set_digits(0)
		self.initial_dents.set_range(20,100)
		self.initial_dents.set_increments(5,5)
		self.initial_dents.set_value_pos(gtk.POS_LEFT)
		#add the dpr to the options
		idhbox.pack_start(self.initial_dents)
		options_box.pack_start(idhbox,False,False,0)
		#how do we handle the link color?
		#don't show this on Maemo
		if not has_hildon:
			colorlabel = gtk.Label("Link Color: ")
			chbox = gtk.HBox(False)
			chbox.pack_start(colorlabel,False,False,0)
			self.color = gtk.Entry()
			self.color.connect('changed', self.check_color )
			self.color.set_tooltip_text("enter a hexidecimal color such as '#3333ff' or a color name such as 'orange'" )
			chbox.pack_start(self.color,False,False,0)
			self.colorevent = gtk.EventBox()
			chbox.pack_start(self.colorevent)
			options_box.pack_start(chbox,False,False,0)
		
		
	def check_color(self,widget):
		color_string = self.color.get_text()
		try:
			color = gtk.gdk.Color(color_string)
			self.set_link_color(color_string)
			self.emit('link-color', color_string)
		except:
			pass
			
	def set_link_color(self,color_name):
		if not self.has_hildon:
			self.color.set_text(color_name)
			the_color = gtk.gdk.color_parse(color_name)
			self.colorevent.modify_bg(gtk.STATE_NORMAL,the_color )
		
	def set_run_as_tray_app(self,boolean):
		self.run_as_tray_app.set_active(boolean)	
	
	def set_context_backwards(self,boolean):
		self.context_back_asswards.set_active(boolean)
		
	def set_no_avatars(self,boolean):
		self.disable_avatars.set_active(boolean)

	#More Code for notifications			
	def set_notifications(self,boolean):
		self.enable_notifications.set_active(boolean)

	def set_notify_replies(self,boolean):
		self.enable_notify_replies.set_active(boolean)
	
	def set_name(self,name):
		self.account_name_entry.set_text(name)

	def set_password(self,password):
		self.account_password_entry.set_text(password)

	def set_initial_dents(self,initial_dents):
		#convert the dents to a number
		self.initial_dents.set_value( int(initial_dents) )

	def submit_clicked(self,widget):
		#get the name and password
		n=self.account_name_entry.get_text()
		p=self.account_password_entry.get_text()
		if n!="" and p!="" :
			self.emit("update-account",n,p)

	def option_toggled(self,widget,signal):
		value = widget.get_active()
		self.emit(signal,value)
		
	def initial_dents_changed(self,widget):
		value = self.initial_dents.get_value()
		self.emit('initial-dents',value)
